
#include <PalmOS.h>
#include <PCENativeCall.h>
#include <PNOLoader.h>
#include <VfsMgr.h>
#include <PalmOSGlue.h>
#include "StarterRsc.h"
#include "host68k.h"
#include "pnobridge.h"
#include "palm5way.h"
#include "starter.h"

#include "MathLib.h"

#include "endianutils.h"

#include "zodiac.h"

#include "C:\\winapp\\Metrowerks\\CodeWarrior9\\CW for Palm OS Support\\(Other SDKs)\\Tapwave 1.1 SDK\\Incs\\TapWave\\TwChars.h"
//#include <TwChars.h>

UInt8 g_paused = 0;
UInt8 g_frameskip = 2;
UInt32 g_bigalloc = 0;

UInt16 palm_vfs_count ( void ) {
  UInt16 volref = 0;
  UInt32 voliter = vfsIteratorStart;
  UInt16 count = 0;

  if ( VFSVolumeEnumerate ( &volref,  &voliter ) != errNone ) {
    return ( 0 ); // error
  }

  count = 1;

  while ( VFSVolumeEnumerate ( &volref,  &voliter ) == errNone ) {
    //if ( voliter != vfsIteratorStop ) {
    count++;
    //}
  }

  return ( count );
}

UInt16 palm_vfs_iter ( void ) {
  UInt16 volref = 0;
  UInt32 voliter = vfsIteratorStart;
  FileRef file;
  UInt16 firstvolref;

  // can we enumerate at all?
  if ( VFSVolumeEnumerate ( &volref,  &voliter ) != errNone ) {
    return ( 0 );
  }

  // store first succeeding volume
  firstvolref = volref;

  // can we open our directory? If so, we found our directory :)
  if ( VFSFileOpen ( volref, VFSPATH, vfsModeRead, &file ) == errNone ) {
    VFSFileClose ( file );
    return ( volref );
  }

  // look through other volumes, trying to find our directory
  while ( VFSVolumeEnumerate ( &volref,  &voliter ) == errNone ) {

    if ( VFSFileOpen ( volref, VFSPATH, vfsModeRead, &file ) == errNone ) {
      VFSFileClose ( file );
      return ( volref );
    }

  }

  //return ( voliter );
  return ( firstvolref );
}

void *hw_query_vram ( void ) {
  WinHandle winh;
  BitmapType *winb;

  winh = WinGetDisplayWindow();
  winb = WinGetBitmap ( winh );

  return ( BmpGetBits ( winb ) );
}

/* set screen to 16bpp mode */
UInt8 hw_set16bpp ( void ) {
  UInt32 depth = 16;
  Boolean colp = true;

  if ( WinScreenMode ( winScreenModeSet, NULL, NULL, &depth, &colp ) 
         != errNone )
  {
    return ( 0 );
  }

  return ( 1 );
}

int update_field ( FormPtr f, int obid, char *newtext ) {
  MemHandle newhandle, oldhandle;
  FieldPtr field;

  newhandle = MemHandleNew ( StrLen ( newtext ) + 1 );

  if ( ! newhandle ) {
    return ( 0 );
  }

  StrCopy ( MemHandleLock ( newhandle ), newtext );
  MemHandleUnlock ( newhandle );

  field = FrmGetObjectPtr ( f, FrmGetObjectIndex ( f, obid ) );

  oldhandle = FldGetTextHandle ( field );

  FldSetTextHandle ( field, newhandle );

  if ( oldhandle ) {
    MemHandleFree ( oldhandle );
  }

  return ( 1 );
}

UInt32 pnobridge_retval = 0;
UInt32 pnobridge_mask = 0;

UInt32 host_event_handler ( UInt32 arg ) {
  UInt8 f;
  UInt32 a;
  static UInt32 accum = 0;

#if 1
  // clear retval
  pnobridge_retval = 0;
#else
  // drop old bits of retval
  pnobridge_retval &= ~pnobridge_mask;
  pnobridge_mask = 0;
  pnobridge_retval &= ~DIRFIREMASK;
#endif

  // normalize args
  f = arg & BRIDGEMASK;
  a = arg >> BRIDGESHIFT;

  if ( f == BRIDGE_MemGluePtrNew ) {
    // memglueptrnew

    //DEBUGS("MemGluePtrNew");
    //DEBUGU32(a);

    pnobridge_retval = (UInt32) MemGluePtrNew ( a );

  } else if ( f == BRIDGE_events ) {
    /*
     * full events!
     */
    EventType event;
    Err error;
    //UInt32 keys;
    UInt8 skipevent;

    /* check buttons and translate to joystick
     */
#if 0
    keys = KeyCurrentState();

    if ( keys & keyBitHard1 || keys & keyBitNavLeft ) {
      pnobridge_retval |= STAT_left;
      g_paused = 0;
    } else if ( keys & keyBitHard2 || keys & keyBitNavRight ) {
      pnobridge_retval |= STAT_right;
      g_paused = 0;
    }
    if ( keys & keyBitPageUp ) {
      pnobridge_retval |= STAT_up;
      g_paused = 0;
    } else if ( keys & keyBitPageDown ) {
      pnobridge_retval |= STAT_down;
      g_paused = 0;
    }
    if ( keys & keyBitHard3 ) {
      pnobridge_retval |= STAT_fire1;
      g_paused = 0;
    }
    if ( keys & keyBitHard4 ) {
      pnobridge_retval |= STAT_fire1; // fire2
      g_paused = 0;
    }
#endif

    /* check pause
     */
    if ( g_paused ) {
      pnobridge_retval |= STAT_pause;
    } else if ( pnobridge_retval & STAT_pause ) {
      pnobridge_retval &= ~STAT_pause;
    }

    /* check events
     */
    while ( /*1*/EvtEventAvail() /* -- breaks keyboards */ ) {
      //EvtGetEvent ( &event, 1 /* evtWaitForever */ );
      //EvtGetEvent ( &event, 0 /* evtWaitForever */ );

      EvtGetEvent ( &event, 0 /* consume all batteries! */ );

      if ( FrmGetActiveFormID() == MainForm ) {

	if ( event.eType == nilEvent ) {
	  break;
	}

	/* key event -- turn real keyboard or grafitti into ST keys
	 */
	if ( event.eType == keyDownEvent ) {

	  // menu event? if so, pause!
	  if ( event.data.keyDown.chr == menuChr ) {
	    g_paused = 1;
	    show_pause();
	  } else if ( IsFiveWayNavEvent ( &event ) ) {
	    // swallow
	    break;
	  } else if ( ( event.data.keyDown.chr >= hardKeyMin ) &&
		      ( event.data.keyDown.chr <= hardKeyMax ) )
	  {
	    // swallow
	    break;
	  } else if ( event.data.keyDown.chr == vchrFunction ) {
	    // swallow
	    break;
	  }

	} else if ( event.eType == ctlSelectEvent ) {

	  if ( event.data.ctlSelect.controlID == StartButton ) {
	    pnobridge_retval |= STAT_start;
	  } else if ( event.data.ctlSelect.controlID == FPSPop ) {
	    ListType *list = (ListType*) GetObjectPtr ( FPSList );

	    LstSetSelection ( list, g_frameskip );
	    LstPopupList ( list );
	    g_frameskip = LstGetSelection ( list );

	    pnobridge_retval |= STAT_skip;
	  }

#if 0
	} else if ( event.eType == penDownEvent ) {

	  if ( event.screenY > 80 ) {
	    pnobridge_retval |= STAT_pause; // special
	  }
#endif

	} // event

      } // emu form?

      /* normal event processing
       */
      if ( event.eType == appStopEvent ) {
	// shove an extra stop event into queue so launcher comes back
	EventType e;
	e.eType = appStopEvent;
	EvtAddEventToQueue ( &e );

	pnobridge_retval |= STAT_exeunt;

      } else {
	if (! SysHandleEvent ( &event ))
	  if (! MenuHandleEvent ( 0, &event, &error ) )
	    if (! AppHandleEvent ( &event ) )
	      FrmDispatchEvent ( &event );
      } /* keydown? */

      /* avoid doing too many events at once while in Emu form.. so
       * bail after each one to spread them out over time
       */
      if ( FrmGetActiveFormID() == MainForm ) {
	break;
      }

    } /* while */

    // end of event loop

  } else if ( f == BRIDGE_bigalloc ) {
    pnobridge_retval = (UInt32) MemGluePtrNew ( 0x400000 );
    //pnobridge_retval = (UInt32) MemPtrNewL ( 0x400000 );
    g_bigalloc = pnobridge_retval;

  } else if ( f == BRIDGE_zodiacblit ) {
    //if ( a == 0 ) {
    //  tw_gfx_blit();
    //} else
    if ( a == 1 ) {
      pnobridge_retval = tw_gfx_lock();
      if ( ! pnobridge_retval ) {
	DEBUGS ( "Couldn't lock display surface!" );
      }
    } else if ( a == 2 ) {
      tw_gfx_unlock();
    } else {
      UInt16 w, h;
      w = a & 0xFFFF;
      h = a >> 16;
      if ( w + h == 0 ) {
	tw_gfx_blit();
      } else {
	tw_gfx_blit2 ( w, h );
      }
    }

  } else if ( f == BRIDGE_bigfree ) {
    MemPtrFree ( (void*) g_bigalloc );
    g_bigalloc = 0;

  } else if ( f == BRIDGE_progress ) {
    WinDrawLine ( 0, 158, a * 160 / 10, 158 );
    WinDrawLine ( 0, 159, a * 160 / 10, 159 );

  } else if ( f == BRIDGE_debugu32 ) {
    //DEBUGU32(a);

  } else if ( f == BRIDGE_printfu32 ) {
    char b [ 40 ];
    StrPrintF ( b, "%lu", a );
    WinDrawChars ( b, StrLen ( b ), 0, 0 );

  } else if ( f == BRIDGE_accum ) {
    accum = a;

  } else if ( f == BRIDGE_setaudio ) {
    UInt32 poop = ( accum << 16 ) | a;
    hostcall_t *h = (hostcall_t*) poop;
    audio_begin ( (void*) h -> a, true, (void*) h -> b );

  } else if ( f == BRIDGE_debugs ) {
    UInt32 poop = ( accum << 16 ) | a;
    char *p = (char*)poop;
    //DEBUGS(p);

  } else if ( f == BRIDGE_printfs ) {
    UInt32 poop = ( accum << 16 ) | a;
    char *p = (char*)poop;
    WinDrawChars ( p, StrLen ( p ), 0, 0 );

  } else if ( f == BRIDGE_get_skip ) {
    pnobridge_retval = g_frameskip;

  } else if ( f == BRIDGE_error ) {

    //DEBUGS ( "error" );

    /*
     * BRIDGE COMMANDS HERE
     */

  } // bridge command

  return ( pnobridge_retval );
}

void show_pause ( void ) {
  char message[] = "P A U S E D";
  WinDrawChars ( message, StrLen ( message ), 60, 60 );
  return;
}

// pass in zero to get a return of number of save files; pass in >0 to
// get details about that file
UInt16 palm_game_count ( UInt16 entry, char *r_filename ) {
  UInt16 volref = palm_vfs_iter();
  FileRef dir;
  FileInfoType file;
  UInt32 diter = vfsIteratorStart;
  char filename [ 256 ] = "";
  UInt16 counter = 0;
  Err error;

  file.nameP = filename; // point to local buffer
  file.nameBufLen = 256; // sizeof ( fileName );

  error = VFSFileOpen ( volref, VFSPATH, vfsModeRead, &dir );

  if ( error != errNone ) {
    return ( 0 );
  }

  while ( diter != vfsIteratorStop ) {
    VFSDirEntryEnumerate ( dir, &diter, &file );

    if ( filename [ 0 ] == '\0' ) {
      continue;
    }

    if ( query_filetype ( filename ) > 0 ) {
      counter++;

      if ( entry == counter ) {
	VFSFileClose ( dir );
	StrToLower ( r_filename, filename );
	//StrCopy ( r_filename, filename );
	return ( 0 );
      }

    }

  } // while

  VFSFileClose ( dir );

  return ( counter );
}

UInt8 is_clie ( void ) {
  UInt32 val;

  if ( ! FtrGet ( sysFtrCreator, sysFtrNumOEMCompanyID, &val ) ) {

    if (val == 'sony' /*sonyHwrOEMCompanyID_Sony*/) {
      /* device might be CLIE */
      return ( 1 );
    } else {
      /* device might not be CLIE */
    }
  } else {
    /* something wrong ... */
  }

  return ( 0 ); /* not clie */
}

// 0 is unknown; 1 is genesis; 2 is SMS/GG; 3 is TG16
UInt8 query_filetype ( char *filename ) {

  //DEBUGS ( filename );

  if ( StrStr ( filename, ".smd" ) ||
       StrStr ( filename, ".SMD" ) ||
       StrStr ( filename, ".bin" ) ||
       StrStr ( filename, ".BIN" ) )
  {
    //DEBUGS ( "genesis" );
    return ( 1 );
  } else if ( StrStr ( filename, ".gg" ) ||
	      StrStr ( filename, ".GG" ) ||
	      StrStr ( filename, ".sms" ) ||
	      StrStr ( filename, ".SMS" ) )
  {
    //DEBUGS ( "smsgg" );
    return ( 2 );
  } else if ( StrStr ( filename, ".pce" ) ||
	      StrStr ( filename, ".PCE" ) )
  {
    //DEBUGS ( "tg16" );
    return ( 3 );
  } else if ( StrStr ( filename, ".vcs" ) ||
	      StrStr ( filename, ".VCS" ) )
  {
    //DEBUGS ( "vcs" ); 
    return ( 4 );
  }

  return ( 0 );
}

char *emu_module [ 6 ] = {
  "unknown.emu",
  "genesis.emu",
  "smsgg.emu",
  "pce.emu",
  "vcs.emu",
  NULL
};

#define memNewChunkFlagNonMovable    0x0200
#define memNewChunkFlagAllowLarge    0x1000  // this is not in the sdk *g*
SysAppInfoPtr 
SysGetAppInfo(SysAppInfoPtr *uiAppPP, SysAppInfoPtr *actionCodeAppPP)
  SYS_TRAP(sysTrapSysGetAppInfo); 

void *MemPtrNewL ( UInt32 size ) {

  SysAppInfoPtr appInfoP;
  UInt16        ownerID;

  ownerID =
    ((SysAppInfoPtr)SysGetAppInfo(&appInfoP, &appInfoP))->memOwnerID;

  return MemChunkNew ( 0, size, ownerID |
		       memNewChunkFlagNonMovable |
		       memNewChunkFlagAllowLarge );

}

void MemPtrFreeL ( void *p ) {
  MemPtrFree ( p );
}
