
#ifndef h_host68k_h
#define h_host68k_h

// passes back into pnolet
extern UInt32 pnobridge_retval;
extern UInt32 pnobridge_mask;
extern UInt8 g_make_package;

// filename of emu modules
extern char *emu_module [ 6 ];

// Define the minimum OS version we support (5.0 for now).
#define kOurMinVersion	sysMakeROMVersion(5,0,0,sysROMStageDevelopment,0)
#define kPalmOS10Version	sysMakeROMVersion(1,0,0,sysROMStageRelease,0)

void *MemPtrNewL ( UInt32 size );
void MemPtrFreeL ( void *ptr );

/* VFS stubs
 */
#ifdef __cplusplus
extern "C"
#endif
UInt16 palm_vfs_count ( void );

#ifdef __cplusplus
extern "C"
#endif
UInt16 palm_vfs_iter ( void );

UInt16 palm_game_count ( UInt16 entry, char *r_filename );

UInt8 query_filetype ( char *filename );

/* hardware stubs
 */
#ifdef __cplusplus
extern "C"
#endif
void *hw_query_vram ( void );

#ifdef __cplusplus
extern "C"
#endif
UInt8 hw_set16bpp ( void );

#ifdef __cplusplus
extern "C"
#endif
int update_field ( FormPtr f, int obid, char *newtext );
char *strdup ( char *text );

#ifdef __cplusplus
extern "C"
#endif
UInt32 host_event_handler ( UInt32 arg );

void * GetObjectPtr ( UInt16 objectID );
void show_pause ( void );

UInt8 is_clie ( void );

/* debug assist
 */
#define DEBUGU8(x) {                                   \
  char buffer [ 200 ];                                 \
  StrPrintF ( buffer, "%u %x", x, x );                 \
  FrmCustomAlert ( MessageAlert, buffer, NULL, NULL ); \
}

#define DEBUGU32(x) {                                  \
  char buffer [ 200 ];                                 \
  StrPrintF ( buffer, "%lu %lx", x, x );               \
  FrmCustomAlert ( MessageAlert, buffer, NULL, NULL ); \
}

#define DEBUGS(s) {                                    \
  FrmCustomAlert ( MessageAlert, s, NULL, NULL );      \
}

#endif
