
#ifndef h_pnobridge_h
#define h_pnobridge_h

#define VERSION "012"

// register your own at http://www.palmos.com/dev/creatorid/
#define appName					"GuineaPig"
#define appFileCreator			'CJGP'
#define appVersionNum			0x01
#define appPrefID				0x00
#define appPrefVersionNum		0x01

#define CREATORID 'CJGP'
#define VFSPATH "/PALM/Programs/GuineaPig/"
#define VFSROOT "/PALM/Programs/"
#define FTR_PNO 0

#define AUDIO_RATE 44100
#define AUDIO_FPS     60
#define AUDIO_STEREO   2 /* or 1 for mono */
#define AUDIO_WIDTH    2 /* or 1 for 8bit */
#define AUDIO_BUFSIZE_BYTES (AUDIO_RATE/AUDIO_FPS*AUDIO_STEREO*AUDIO_WIDTH)
#define AUDIO_BUFSIZE_FRAMES (AUDIO_RATE/AUDIO_FPS)
#define AUDIO_FMT      sndInt16Little

//#define AUDIO_ARM      1 /* if audio-arm defined, then do arm callback */
//#define AUDIO_VOLUME 20 /* see audio_volume(); *64 */

// debug in pno?
//#define PNODEBUG 1

typedef struct {
  UInt32 vfs_max; // number of VFS volumes available
  UInt32 vfs_vol; // volume we actually want to use
  UInt32 vram;    // address of screen VRAM
  UInt32 eventf;  // function pointer to 68k func to do event handling
  UInt32 display_pitch;  // screenbuffer width
  UInt32 display_width;  // X width of display
  UInt32 display_height; // Y height of display
  UInt32 game_rom;       // pointer to chosen game rom filename
  UInt32 audio_buf;      // pointer to audio buffer
  UInt32 flags;          // flags for pnolet
} pnobridge_t;

// for requesting data from the 68k side, from the pnolet
#define BRIDGESHIFT 4
#define BRIDGEMASK  0x0F
enum {
  BRIDGE_MemGluePtrNew = 1,
  BRIDGE_debugu32,
  BRIDGE_printfu32,
  BRIDGE_accum,
  BRIDGE_debugs,
  BRIDGE_printfs,
  BRIDGE_events,
  BRIDGE_error,
  BRIDGE_progress,
  BRIDGE_setaudio,
  BRIDGE_bigalloc,
  BRIDGE_get_skip,
  BRIDGE_bigfree,
  BRIDGE_zodiacblit,
  BRIDGE_max
};

// bridge options going into the pno
#define BF_FULLSCREEN 1
#define BF_AUDIO      2
#define BF_LOWMEM     4
#define BF_ZODIAC     8

// for calling back from pno to host
typedef struct {
  UInt32 a;
  UInt32 b;
  UInt32 c;
  UInt32 d;
} hostcall_t;

// returning status from event check; buttons and other stuff..
enum {
  STAT_left = 1,
  STAT_right = 2,
  STAT_up = 4,
  STAT_down = 8,
  STAT_fire1 = 16,
  STAT_fire2 = 32,
  STAT_exeunt = 64,
  STAT_pause = 128,
  STAT_start = 256,
  STAT_skip = 512,
  STAT_max
};

// go to 68k side and ask it to do events, returning the goods
UInt32 host_events ( UInt32 foo );
void *GetObjectPtr ( UInt16 objectID );

extern pnobridge_t *g_pnobridge;

#endif
