
//#include "palmdep.h"

#include "palmdep.h"
#include "endianutils.h"
#include "pnobridge.h"
#include "oscompat.h"
#include "endianutils.h"

#include "StarterRsc.h"
#include "palm5way.h"
#include "pnobridge.h"


#include "shared.h"

static uint8 block[0x4000];
extern UInt32 cart_rom_size;

void deinterleave_block(uint8 *src)
{
    int i;
    memcpy(block, src, 0x4000);
    for(i = 0; i < 0x2000; i += 1)
    {
        src[i*2+0] = block[0x2000 + (i)];
        src[i*2+1] = block[0x0000 + (i)];
    }
}

int load_rom(char *filename)
{
    int size, offset = 0;
    uint8 header[0x200];
    uint8 *ptr;

    // load rom into memory
    ptr = load_archive(filename, &size);
    if(!ptr) return (0);

    // malloc some memory for the cart
    if ( g_pnobridge -> flags & BF_LOWMEM ) {
      cart_rom = MemGluePtrNewL ( size );
      cart_rom_size = size;
    } else {
      cart_rom = (void*) MemCart();

      if ( ! cart_rom ) {
	cart_rom = MemGluePtrNewL ( size );
	cart_rom_size = size;
      }

    }
    if ( ! cart_rom ) {
      DEBUGS ( "Couldn't alloc cartridge rom space (runtime RAM)" );
      free ( ptr );
      return ( 0 );
    }

    // continue loading
    if((size / 512) & 1)
    {
        int i;

        size -= 512;
        offset += 512;

        memcpy(header, ptr, 512);

        for(i = 0; i < (size / 0x4000); i += 1)
        {
            deinterleave_block(ptr + offset + (i * 0x4000));
        }
    }

    memset(cart_rom, 0, cart_rom_size/*0x400000*/);
    if(size > 0x400000) size = cart_rom_size/*0x400000*/;
    memcpy(cart_rom, ptr + offset, size);

    /* Free allocated file data */
    free(ptr);

    return (1);
}



