/*
    loadrom.c --
    File loading and management.
*/

#include "palmdep.h"
#define stricmp StrCaselessCompare

#include "shared.h"

char game_name[1024];

int load_rom(char *filename)
{
    int size;

#if 0
    if(stricmp(strrchr(filename, '.'), ".zip") == 0)
    {
        char name[0x100];

        cart.rom = loadzip(filename, name, &size);
        if(!cart.rom) return 0;
        strcpy(game_name, name);

        /* Take care of image header, if present */
        if((size / 512) & 1)
        {
            size -= 512;
            memmove(cart.rom, cart.rom + 512, size);
        }

        cart.pages = (size / 0x4000);
    }
    else
    {
        FILE *fd = NULL;

        fd = fopen(filename, "rb");
        if(!fd) return 0;

        /* Seek to end of file, and get size */
        fseek(fd, 0, SEEK_END);
        size = ftell(fd);
        fseek(fd, 0, SEEK_SET);

        /* Don't load games smaller than 32k */
        if(size < 0x8000) return 0;

        /* Take care of image header, if present */
        if((size / 512) & 1)
        {
            size -= 512;
            fseek(fd, 512, SEEK_SET);
        }

        cart.pages = (size / 0x4000);
        cart.rom = malloc(size);
        if(!cart.rom) return 0;
        fread(cart.rom, size, 1, fd);

        fclose(fd);
    }
#endif

#if 1
 {
	FILE *f = fopen ( filename, "rb" );

	if ( ! f ) {
	  return ( NULL );
	}

	fseek ( f, 0, SEEK_END );
	size = ftell ( f );
	fseek ( f, 0, SEEK_SET );

        /* Don't load games smaller than 32k */
        if(size < 0x8000) return 0;

        /* Take care of image header, if present */
        if((size / 512) & 1)
        {
            size -= 512;
            fseek(f, 512, SEEK_SET);
        }

        cart.pages = (size / 0x4000);
        cart.rom = MemGluePtrNewL ( size );
        if(!cart.rom) return 0;
        fread(cart.rom, size, 1, f);

	fclose ( f );

        /* Update file size and return pointer to file data */
        //*file_size = size;
        //return (buf);
 }
    strcpy ( game_name, filename );
#endif

    /* Figure out game image type */
    if ( ( StrStr(/*strrchr(*/game_name/*, '.')*/, ".gg") == 0 ) ||
	 ( StrStr ( game_name, ".GG" ) == 0 ) )
    {
      cart.type = TYPE_GG;
      //DEBUGS ( "Game is GG" );
    } else {
      cart.type = TYPE_SMS;
      //DEBUGS ( "Game is SMS" );
    }

    return 1;
}

unsigned char *loadzip(char *archive, char *filename, int *filesize)
{
    char name[0x100];
    unsigned char *buffer;

    int zerror = UNZ_OK;
    unzFile zhandle;
    unz_file_info zinfo;

    zhandle = unzOpen(archive);
    if(!zhandle) return (NULL);

    /* Seek to first file in archive */
    zerror = unzGoToFirstFile(zhandle);
    if(zerror != UNZ_OK)
    {
        unzClose(zhandle);
        return (NULL);
    }

    /* Get information about the file */
    unzGetCurrentFileInfo(zhandle, &zinfo, &name[0], 0xff, NULL, 0, NULL, 0);
    *filesize = zinfo.uncompressed_size;

    /* Error: file size is zero */
    if(*filesize <= 0)
    {
        unzClose(zhandle);
        return (NULL);
    }

    /* Open current file */
    zerror = unzOpenCurrentFile(zhandle);
    if(zerror != UNZ_OK)
    {
        unzClose(zhandle);
        return (NULL);
    }

    /* Allocate buffer and read in file */
    buffer = malloc(*filesize);
    if(!buffer) return (NULL);
    zerror = unzReadCurrentFile(zhandle, buffer, *filesize);

    /* Internal error: free buffer and close file */
    if(zerror < 0 || zerror != *filesize)
    {
        free(buffer);
        buffer = NULL;
        unzCloseCurrentFile(zhandle);
        unzClose(zhandle);
        return (NULL);
    }

    /* Close current file and archive file */
    unzCloseCurrentFile(zhandle);
    unzClose(zhandle);

    memcpy(filename, name, 0x100);
    return (buffer);
}

