
#include "palmdep.h"
#include "endianutils.h"
#include "pnobridge.h"
#include "oscompat.h"
#include "endianutils.h"

#include "StarterRsc.h"
#include "palm5way.h"
#include "pnobridge.h"

//#include "C:\\winapp\\Metrowerks\\CodeWarrior9\\CW for Palm OS Support\\(Other SDKs)\\Tapwave R4 SDK\\Incs\\TapWave\\TwChars.h"
//#include "C:\\winapp\\Metrowerks\\CodeWarrior9\\CW for Palm OS Support\\(Other SDKs)\\Tapwave R4 SDK\\Incs\\TapWave\\TwKeys.h"

//#include "c:/winapp/Metrowerks/CodeWarrior9/CW for Palm OS Support/MSL/MSL_C/MSL_Common/Include/math.h"

#include "shared.h"

void PutImage ( void );
void audio_gen ( void );
unsigned char run_host ( void );
void stubaudiof ( void *s );
Err audio_callback_extended
 ( void *userData, SndStreamRef stream, void *buffer, UInt32* bufsize );
UInt32 host_get_skip ( UInt8 foo );

UInt8 *backbuffer = NULL;

// features
#define F_FPS 1           /* nolonger needed */
#define F_DO_EVENTS 1

#ifdef F_FPS
UInt32 fps_lasttime = 0;
UInt32 fps_counter = 0;
char fps_buffer [ 10 ] = "FPS: ";
#endif

// conveniance pointers
UInt16 display_pitch;
UInt16 ticks_per_sec;

// Linker still looks for ARMlet_Main as entry point, but the
// "ARMlet" name is now officially discouraged.  Compare an
// contrast to "PilotMain" for 68K applications.
#define PNO_Main ARMlet_Main

// Define DEBUG as 0 to turn off debugging support in the PNO.
// With this on, the PNO will register itself with the Palm OS
// Debugger on startup, allowing stepping through the code.
#define DEBUG 0

// ------------------------

unsigned long PNO_Main(
	const void *emulStateP, 
	void *userData68KP, 
	Call68KFuncType *call68KFuncP);

unsigned long Run ( void );

Call68KFuncType * g_my_call68KFuncP;
const void *g_my_emulStateP;
pnobridge_t *g_pnobridge;

UInt32 g_host = 0;
UInt8 g_running = 0;
UInt8 g_frameskip = 2;

unsigned long PNO_Main(
	const void *emulStateP, 
	void *userData68KP, 
	Call68KFuncType *call68KFuncP)
{

#ifdef PNODEBUG
  AdnDebugNativeRegister ( 'appl', 'STRT', 'ARMC', 1 );
#endif

  // needed before making any OS calls using the 
  // PACEInterface library
  InitPACEInterface ( emulStateP, call68KFuncP );

  // my cheap hack to get StrAToI happy without modifying paceinterfacelib
  g_my_call68KFuncP = call68KFuncP;
  g_my_emulStateP = emulStateP;
  g_pnobridge = userData68KP;

  g_pnobridge -> vfs_max = ByteSwap32 ( g_pnobridge -> vfs_max );
  g_pnobridge -> vfs_vol = ByteSwap32 ( g_pnobridge -> vfs_vol );
  g_pnobridge -> vram = ByteSwap32 ( g_pnobridge -> vram );
  g_pnobridge -> eventf = ByteSwap32 ( g_pnobridge -> eventf );
  g_pnobridge -> display_width = ByteSwap32 ( g_pnobridge -> display_width );
  g_pnobridge -> display_height = ByteSwap32 ( g_pnobridge -> display_height );
  g_pnobridge -> display_pitch = ByteSwap32 ( g_pnobridge -> display_pitch );
  g_pnobridge -> game_rom = ByteSwap32 ( g_pnobridge -> game_rom );
  g_pnobridge -> audio_buf = ByteSwap32 ( g_pnobridge -> audio_buf );
  g_pnobridge -> flags = ByteSwap32 ( g_pnobridge -> flags );

  display_pitch = g_pnobridge -> display_pitch;

  // do something useful
  return ( Run() );
}

unsigned long Run ( void ) {
  UInt32 g_host = 0;
  UInt32 keys;
  UInt8 hostcount = 0;
  UInt8 frameskip = g_frameskip;

  /* kickoff
   */
  ticks_per_sec = SysTicksPerSecond();

  /* init engine
   */

  /* init
   */
  debuglog ( "Load ROM ..." );
  load_rom ( (char*) ( g_pnobridge -> game_rom ) );

  // set audio function
  //stubaudiof ( audio_callback_extended );

  /* define display
   */
  if ( g_pnobridge -> flags & BF_FULLSCREEN ) {
    backbuffer = MemGluePtrNewL ( 640 * 480 * 2 );
    if ( ! backbuffer ) {
      DEBUGS ( "Couldn't get enough memory for scaling." );
    }
  }

  memset ( &bitmap, sizeof(t_bitmap), 0 );
  bitmap.width  = 320;
  bitmap.height = 200;
  bitmap.depth  = 16;
  bitmap.granularity = 2; /* Bytes per pixel */
  bitmap.viewport.w = 256;
  bitmap.viewport.h = 192;

  if ( backbuffer ) {
    bitmap.pitch  = 640 * 2;
    bitmap.data   = (unsigned char *) backbuffer + ( bitmap.pitch * 32 );
  } else {
    bitmap.data   = (unsigned char *) g_pnobridge -> vram + ( display_pitch * 32 * 2 ); /* Pointer to your bitmap */
    bitmap.pitch = g_pnobridge -> display_pitch * 2; //(bitmap.width * bitmap.granularity);
  }

  /* start emu; includes emu main loop..
   */
  debuglog ( "Init the emulator" );

  /* fire up audio or engine
   */
  if ( g_pnobridge -> flags & BF_AUDIO ) {
    debuglog ( "Init audio" );
    //audio_init ( 44100 );
    system_init ( 44100 );
  } else {
    system_init ( 0 );
  }

  /* reset
   */
  debuglog ( "Reset the machine" );
  system_reset();

  // zodiac keys
#define	keyBitJogBack		0x00008000	// jog wheel back button
#define keyBitFunction          keyBitJogBack
#define keyBitTriggerA          0x04000000
#define keyBitTriggerB          0x08000000
#define keyBitActionA           0x10000000
#define keyBitActionB           0x20000000
#define keyBitActionC           0x40000000
#define keyBitActionD           0x80000000

  /* run it!
   */
  g_running = 1;
  while ( g_running ) {

    g_host = 0;
    if ( hostcount++ > 3 ) {
      g_host = host_events ( 0 );
      hostcount = 0;
    }

    keys = KeyCurrentState();

    if ( g_host & STAT_exeunt ) {
      return ( 0 );
    }

    if ( g_host & STAT_skip ) {
      g_frameskip = host_get_skip ( 0 );
    }

#if 1
    input.pad[0] = 0;

    if ( g_host & STAT_start ) {
      input.system |= INPUT_START;
    }
    if ( keys & keyBitFunction ) {
      input.system |= INPUT_START;
    }

    if ( keys & keyBitHard1 || keys & keyBitNavLeft ) {
      input.pad[0] |= INPUT_LEFT;
    } else if ( keys & keyBitHard2 || keys & keyBitNavRight ) {
      input.pad[0] |= INPUT_RIGHT;
    } else if ( keys & keyBitPageUp ) {
      input.pad[0] |= INPUT_UP;
    } else if ( keys & keyBitPageDown ) {
      input.pad[0] |= INPUT_DOWN;
    }
    if ( keys & keyBitHard3 ) {
      input.pad[0] |= INPUT_BUTTON1;
    }
    if ( keys & keyBitHard4 ) {
      input.pad[0] |= INPUT_BUTTON2;
    }
    if ( keys & keyBitActionC || keys & keyBitNavSelect ) {
      input.pad[0] |= INPUT_BUTTON2;
    }
#endif

#ifdef F_FPS
    // fps counter
    if ( TimGetSeconds() == fps_lasttime ) {
      fps_counter++;
    } else {
      StrIToA ( fps_buffer + 4, fps_counter * 2 );
      fps_counter = 0;
      fps_lasttime = TimGetSeconds();
    }
    WinDrawChars ( "          ", 10, 120, 140 );
    WinDrawChars ( fps_buffer, StrLen ( fps_buffer ), 120, 140 );
#endif

    if ( frameskip == g_frameskip ) {
      system_frame ( 0 );
      if ( frameskip ) {
	frameskip--;
      }
      // blit if theres a backbuffer in use
      if ( backbuffer ) {
	UInt16 x, y;
	UInt16 xmax = bitmap.viewport.w;
	UInt16 ymax = bitmap.viewport.h;
	UInt16 *fline, *tline;
	UInt16 *f, *t, *tline2, *t2;

	fline = ((UInt16*)bitmap.data) + bitmap.viewport.x;
	tline = ((UInt16*) g_pnobridge -> vram) + ( 32 * display_pitch );
	for ( y = 0; y < ymax; y++ ) {
	  f = fline;
	  t = tline;
	  for ( x = 0; x < xmax; x++ ) {
	    *t++ = *f;
	    if ( x & 1 ) {
	      *t++ = *f;
	    }
	    f++;
	  }
	  fline += bitmap.pitch / 2;
	  tline += display_pitch;
	}
      } // backbuffer?
    } else {
      system_frame ( 1 );
      if ( frameskip ) {
	frameskip--;
      }
      if ( ! frameskip ) {
	frameskip = g_frameskip;
      }
    }

    if ( g_pnobridge -> flags & BF_AUDIO ) {
      audio_gen();
    }

    /* throttle?
     */
    {
      static UInt32 lasttime = 0;
      if ( lasttime ) {
	while ( TimGetTicks() - lasttime < ticks_per_sec / 30 ) {
	  // spin
	  if ( g_pnobridge -> flags & BF_AUDIO ) {
	    audio_gen();
	  }
	}
      }
      lasttime = TimGetTicks();
    } // throttle

  } // while running

  /* kill coleco off
   */
  if ( backbuffer ) {
    MemPtrFree ( backbuffer );
  }
  //trash_machine();
  system_shutdown();
  //error_shutdown();
  //MemPtrFree ( cart_rom );

  DEBUGS ( "Please pinhole reset to clear up memory" );

  // done
  return ( 0 );
}

UInt32 host_events ( UInt32 foo ) {
  UInt32 r;
  UInt32 arg;

  arg = BRIDGE_events | ( foo << BRIDGESHIFT );
  arg = ByteSwap32 ( arg );

  r = g_my_call68KFuncP ( g_my_emulStateP,
			  (UInt32) g_pnobridge -> eventf, &arg, 4 );

  return ( r );
}

UInt32 host_get_skip ( UInt8 foo ) {
  UInt32 r;
  UInt32 arg;

  arg = BRIDGE_get_skip | ( foo << BRIDGESHIFT );
  arg = ByteSwap32 ( arg );

  r = g_my_call68KFuncP ( g_my_emulStateP,
			  (UInt32) g_pnobridge -> eventf, &arg, 4 );

  return ( r );
}

long int StrAToI ( const char *ptr ) {
  UInt8 params [ 4 ];

  params [ 0 ] = (UInt8)((UInt32)(ptr) >> 24);
  params [ 1 ] = (UInt8)((UInt32)(ptr) >> 16);
  params [ 2 ] = (UInt8)((UInt32)(ptr) >> 8);
  params [ 3 ] = (UInt8)(ptr);

  return ((long int)((g_my_call68KFuncP)( (void *)(g_my_emulStateP),
				       (0xA0CE & (0x00000FFF)),
				       &params, sizeof(params))));
}

UInt32 TimGetTicks ( void ) {
  return (( UInt32)((g_my_call68KFuncP)( (void*)(g_my_emulStateP),
					 (0xA0F7 & (0x00000FFF)), 0, 0)));
}

UInt16 SysTicksPerSecond ( void ) {
  return (( UInt16)((g_my_call68KFuncP)( (void*)(g_my_emulStateP),
					 (0xA2E9 & (0x00000FFF)), 0, 0)));
}

UInt32 KeyCurrentState ( void ) {
  return (( UInt32)((g_my_call68KFuncP)( (void*)(g_my_emulStateP),
					 (0xA2A2 & (0x00000FFF)), 0, 0)));
}

void *GetObjectPtr ( UInt16 objectID ) {
  FormPtr frmP;
  frmP = FrmGetActiveForm();
  return FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, objectID));
}

void *MemGluePtrNewL ( UInt32 foo ) {
  UInt32 r;
  UInt32 arg;

  arg = BRIDGE_MemGluePtrNew | ( foo << BRIDGESHIFT );
  arg = ByteSwap32 ( arg );

  r = g_my_call68KFuncP ( g_my_emulStateP,
			  (UInt32) g_pnobridge -> eventf, &arg, 4 );

  return ( (UInt8*) r );
}

UInt16 palm_vfs_iter ( void ) {
  return ( g_pnobridge -> vfs_vol );
}

UInt16 palm_vfs_count ( void ) {
  return ( g_pnobridge -> vfs_max );
}

/* -----------------------------------------------------------------------
 */
UInt16 palmap [ 16 ];
#if 0
void SetColor ( byte N, byte R, byte G, byte B ) {
  //XPal [ N ] = ( ( (R) << 11 ) | ( (G) << 5 ) | B );
  XPal [ N ] = N;
  R >>= 3;
  G >>= 2;
  B >>= 3;
  palmap [ N ] = ( ( (R) << 11 ) | ( (G) << 5 ) | B );
  return;
}
#endif

void PutImage ( void ) {
  UInt16 x, y;
  UInt16 *to;
  UInt16 *to2;
  UInt8 *from;

#if 0 // slower
  for ( y = 0; y < HEIGHT; y++ ){
    for ( x = 0; x < WIDTH; x++ ){
      from = XBuf + ( y * WIDTH ) + x;
      to = vram + ( ( y + 32 ) * display_pitch ) + x;
      *to = palmap [ *from ];
    }
  }
#endif

#if 0 // faster
  if ( g_pnobridge -> flags & BF_FULLSCREEN ) {
    UInt32 rowscale;
    UInt16 c;

    for ( y = 0; y < HEIGHT; y++ ){

      if ( y & 1 ) {
	// odd -- mult prev by 1.5, next two rows
	rowscale = ( (y-1) * 2 ) - ( (y-1) / 2 ) + 1;
	to = vram + ( rowscale * display_pitch ) + 0;
	to2 = to + display_pitch;
      } else {
	// even -- mult by 1.5
	rowscale = ( y * 2 ) - ( y / 2 );
	to = vram + ( rowscale * display_pitch ) + 0;
      }

      from = XBuf + ( y * WIDTH );

      for ( x = 0; x < WIDTH; x++ ){
	c = palmap [ *from ];
	*to++ = c;
	if ( x & 1 ) {
	  *to++ = c;
	}
	if ( y & 1 ) {
	  *to2++ = c;
	  if ( x & 1 ) {
	    *to2++ = c;
	  }
	}
	from++;
      } // for x

    } // for y

  } else {
    // simple and fast

    for ( y = 0; y < HEIGHT; y++ ){
      from = XBuf + ( y * WIDTH );
      to = vram + ( ( y + 32 ) * display_pitch ) + 24;
      for ( x = 0; x < WIDTH; x++ ){
	*to++ = palmap [ *from++ ];
      }
    }

  } // scale
#endif

  return;
}

void stubaudiof ( void *s ) {
  UInt32 r;
  UInt32 arg;
  UInt32 foo = (UInt32) s;

  arg = BRIDGE_accum | ( ((foo&0xFFFF0000)>>16) << 8 );
  arg = ByteSwap32 ( arg );
  r = g_my_call68KFuncP ( g_my_emulStateP,
			  (UInt32) g_pnobridge -> eventf, &arg, 4 );

  arg = BRIDGE_setaudio | ( (foo&0x0000FFFF) << 8 );
  arg = ByteSwap32 ( arg );
  r = g_my_call68KFuncP ( g_my_emulStateP,
			  (UInt32) g_pnobridge -> eventf, &arg, 4 );

  return;
}

Err audio_callback_extended
  ( void *userData, SndStreamRef stream, void *buffer, UInt32* bufsize )
{
  return ( errNone );
}

void error ( char *msg, ... ) {
  debuglog ( msg );
  return;
}

void audio_gen ( void ) {
  Int16 *buf_ptr = (Int16 *) g_pnobridge -> audio_buf;
  UInt8 *source = (UInt8*) buf_ptr;
  UInt16 max;
  UInt8 scale;

  if ( source [ 0 ] == 0 ) {
    source [ 0 ] = 1;
    source += 2;
    source += AUDIO_BUFSIZE_BYTES;
  } else {
    source [ 0 ] = 0;
    source += 2;
  }
  buf_ptr = (Int16*) source;

  //MemMove ( buf_ptr, snd.buffer [ 0 ], snd.bufsize * 2 );

  if ( snd.bufsize < AUDIO_BUFSIZE_FRAMES ) {
    max = snd.bufsize;
    scale = AUDIO_BUFSIZE_FRAMES / snd.bufsize;
  } else {
    max = AUDIO_BUFSIZE_FRAMES;
    scale = 1;
  }

  { // gen
    UInt16 i = 0, f = 0;
    UInt8 si;

#if 0
    while ( f < max ) {
      for ( si = 0; si < scale; si++ ) {
	buf_ptr [ i++ ] = snd.buffer [ 0 ] [ f % snd.bufsize ];
	buf_ptr [ i++ ] = snd.buffer [ 1 ] [ f % snd.bufsize ];
      }
      f++;
    } // while
#endif
    while ( f < max ) {
      buf_ptr [ i++ ] = snd.buffer [ 0 ] [ f % snd.bufsize ];
      buf_ptr [ i++ ] = snd.buffer [ 1 ] [ f % snd.bufsize ];
      f++;
    } // while

 } // gen

#if 0 // worked sort of
  if ( snd.bufsize < AUDIO_SIZE ) {
    UInt16 a = 0, b = 0;
    while ( a < AUDIO_SIZE ) {
      buf_ptr [ a++ ] = snd.buffer [ 0 ][ b++ % snd.bufsize ];
    }
  } else {
    MemMove ( buf_ptr, snd.buffer, AUDIO_SIZE * 2/*snd.bufsize * 2*/ );
  }
#endif

  return;
}

void system_load_sram ( void ) {
  return;
}
