
#include "palmdep.h"
#include "endianutils.h"
#include "pnobridge.h"
#include "oscompat.h"
#include "endianutils.h"

#include "StarterRsc.h"
#include "palm5way.h"
#include "pnobridge.h"

#include "gpcompat.h"

// for VCS
#define RELEASE
#include "types.h"
#include "files.h"
#include "vmachine.h"
#include "display.h"
#include "keyboard.h"
#include "config.h"
//#include "string.h"
#include "extern.h"
#include "tiasound.h"
#define STICK 	0x01
#define PADDLE 	0x02
#define KEYPAD  0x03
extern __inline void mainloop();


//#include "C:\\winapp\\Metrowerks\\CodeWarrior9\\CW for Palm OS Support\\(Other SDKs)\\Tapwave R4 SDK\\Incs\\TapWave\\TwChars.h"
//#include "C:\\winapp\\Metrowerks\\CodeWarrior9\\CW for Palm OS Support\\(Other SDKs)\\Tapwave R4 SDK\\Incs\\TapWave\\TwKeys.h"

UInt32 stubzodiacblit ( UInt32 mode );
void audio_gen ( void );
unsigned char run_host ( void );
void stubaudiof ( void *s );
Err audio_callback_extended
  ( void *userData, SndStreamRef stream, void *buffer, UInt32* bufsize );
UInt32 host_get_skip ( UInt8 foo );

UInt8 *backbuffer = NULL;
UInt8 *vram8 = NULL;

struct resource {
	int rr;
	int debug;
	char bank;
	char pad_sens;
	char sc;
	char autoconfig;
	char left;
	char right;
	char swap;
} app_data;
GP_HPALETTE h_pal;
char cart_loaded = 0;
int ExKey;
unsigned char current_screen = SCREEN_EMU;
//unsigned short nflip = 0;

UInt16 g_palette [ 256 ];

// features
#define F_FPS 1           /* nolonger needed */
#define F_DO_EVENTS 1

#ifdef F_FPS
UInt32 fps_lasttime = 0;
UInt32 fps_counter = 0;
char fps_buffer [ 10 ] = "FPS: ";
#endif

// conveniance pointers
UInt16 display_pitch;
UInt16 ticks_per_sec;

// Linker still looks for ARMlet_Main as entry point, but the
// "ARMlet" name is now officially discouraged.  Compare an
// contrast to "PilotMain" for 68K applications.
#define PNO_Main ARMlet_Main

// Define DEBUG as 0 to turn off debugging support in the PNO.
// With this on, the PNO will register itself with the Palm OS
// Debugger on startup, allowing stepping through the code.
#define DEBUG 0

// ------------------------

unsigned long PNO_Main(
	const void *emulStateP, 
	void *userData68KP, 
	Call68KFuncType *call68KFuncP);

unsigned long Run ( void );

Call68KFuncType * g_my_call68KFuncP;
const void *g_my_emulStateP;
pnobridge_t *g_pnobridge;

UInt32 g_host = 0;
UInt32 g_host_start = 0;
UInt8 g_running = 0;
UInt8 g_frameskip = 2;

unsigned long PNO_Main(
	const void *emulStateP, 
	void *userData68KP, 
	Call68KFuncType *call68KFuncP)
{

#ifdef PNODEBUG
  AdnDebugNativeRegister ( 'appl', 'STRT', 'ARMC', 1 );
#endif

  // needed before making any OS calls using the 
  // PACEInterface library
  InitPACEInterface ( emulStateP, call68KFuncP );

  // my cheap hack to get StrAToI happy without modifying paceinterfacelib
  g_my_call68KFuncP = call68KFuncP;
  g_my_emulStateP = emulStateP;
  g_pnobridge = userData68KP;

  g_pnobridge -> vfs_max = ByteSwap32 ( g_pnobridge -> vfs_max );
  g_pnobridge -> vfs_vol = ByteSwap32 ( g_pnobridge -> vfs_vol );
  g_pnobridge -> vram = ByteSwap32 ( g_pnobridge -> vram );
  g_pnobridge -> eventf = ByteSwap32 ( g_pnobridge -> eventf );
  g_pnobridge -> display_width = ByteSwap32 ( g_pnobridge -> display_width );
  g_pnobridge -> display_height = ByteSwap32 ( g_pnobridge -> display_height );
  g_pnobridge -> display_pitch = ByteSwap32 ( g_pnobridge -> display_pitch );
  g_pnobridge -> game_rom = ByteSwap32 ( g_pnobridge -> game_rom );
  g_pnobridge -> audio_buf = ByteSwap32 ( g_pnobridge -> audio_buf );
  g_pnobridge -> flags = ByteSwap32 ( g_pnobridge -> flags );

  display_pitch = g_pnobridge -> display_pitch;
  vram8 = (UInt8*) (g_pnobridge -> vram);

  // do something useful
  return ( Run() );
}

unsigned long Run ( void ) {
  UInt32 g_host = 0;
  UInt32 keys;
  UInt8 hostcount = 0;
  UInt8 frameskip = g_frameskip;
  UInt8 nofps = 0;

  /* kickoff
   */
  ticks_per_sec = SysTicksPerSecond();

  /* init engine
   */
  mainloop_init();

  /* init
   */
  app_data.rr=2; // frameskip
  app_data.debug=0;
  app_data.bank=2;
  app_data.pad_sens=5;
  app_data.sc=0;
  app_data.left=STICK;
  app_data.right=STICK;
  /*	paddle1.pos=0;
	paddle1.val=0;*/
  app_data.autoconfig=0;
  app_data.swap=0;

  /* define display
   */
  if ( g_pnobridge -> flags & BF_FULLSCREEN ) {
    backbuffer = MemGluePtrNewL ( 640 * 480 * 2 );
    if ( ! backbuffer ) {
      DEBUGS ( "Couldn't get enough memory for clean display.." );
    }
  }

  /* start emu; includes emu main loop..
   */
  debuglog ( "Init the emulator" );

  /* fire up audio or engine
   */
  if ( g_pnobridge -> flags & BF_AUDIO ) {
    debuglog ( "Init audio" );
    Tia_sound_init(31400,22050);
    //system_init ( 44100 );

#ifdef AUDIO_ARM
    // set audio function
    {
      hostcall_t h;
      h.a = (UInt32) ByteSwap32(audio_callback_extended);
      h.b = (UInt32) &snd;
      //h.b = g_pnobridge -> audio_buf; // works
      stubaudiof ( &h );
    }
#endif

  } else {
    //system_init ( 0 );
  }

  /* reset
   */
  debuglog ( "Reset the machine" );

  // zodiac keys
#define	keyBitJogBack		0x00008000	// jog wheel back button
#define keyBitFunction          keyBitJogBack
#define keyBitTriggerA          0x04000000
#define keyBitTriggerB          0x08000000
#define keyBitActionA           0x10000000
#define keyBitActionB           0x20000000
#define keyBitActionC           0x40000000
#define keyBitActionD           0x80000000

  /* run it!
   */
  g_running = 1;

  loadNewCart ( (char*) (g_pnobridge -> game_rom) );
  mainloop_init();

  while ( g_running ) {

    mainloop();

    g_host = 0;
    if ( hostcount++ > 3 ) {
      g_host = host_events ( 0 );
      hostcount = 0;
    }

    if ( g_host & STAT_exeunt ) {
      return ( 0 );
    }

    if ( g_host & STAT_skip ) {
      g_frameskip = host_get_skip ( 0 );
    }

    if ( g_host & STAT_start ) {
      g_host_start = g_host;
    }

#if 1
    if ( frameskip == g_frameskip ) {
      if ( frameskip ) {
	frameskip--;
      }
      // blit
      if ( backbuffer ) {
	UInt16 x, y;
	UInt16 xmax = 320;
	UInt16 ymax = 200; //240;
	UInt16 *fline, *tline;
	UInt16 *f, *t, *tline2, *t2;
	UInt16 *bb16 = (UInt16*) backbuffer;

	fline = bb16;
	tline = ((UInt16*) g_pnobridge -> vram) + ( 32 * display_pitch );

	if ( g_pnobridge -> flags & BF_FULLSCREEN ) {

	  if ( g_pnobridge -> flags & BF_ZODIAC ) {
	    // hardware scaling mode
	    UInt16 *zram = (UInt16*) stubzodiacblit ( 1 ); // lock surface
	    UInt32 s;

	    nofps = 1;

	    tline = zram;

	    for ( y = 0; y < ymax; y++ ) {
	      f = fline;
	      t = tline;
	      for ( x = 0; x < xmax; x++ ) {
		*t++ = *f++;
	      }
	      fline += 320;
	      tline += display_pitch;
	    }

	    stubzodiacblit ( 2 ); // unlock surface

	    // blit surface with sizing information
	    s = 320;
	    s |= 200 << 16;
	    stubzodiacblit ( s ); // blit surface

	  } else {
	    // software scaling mode
	    for ( y = 0; y < ymax; y++ ) {
	      f = fline;
	      t = tline;
	      for ( x = 0; x < xmax; x++ ) {
		*t++ = *f;
		if ( x & 1 ) {
		  *t++ = *f;
		}
		f++;
	      }
	      fline += 320;
	      tline += display_pitch;
	    }
	  }
	} else {
#if 0
	  for ( y = 0; y < ymax; y++ ) {
	    f = fline;
	    t = tline;
	    for ( x = 0; x < xmax; x++ ) {
	      *t++ = g_palette [ *f ];
	      f++;
	    }
	    fline += 320;
	    tline += display_pitch;
	  }
#endif
	}

      } // backbuffer?
    } else {
      if ( frameskip ) {
	frameskip--;
      }
      if ( ! frameskip ) {
	frameskip = g_frameskip;
      }
    }
#endif

#ifdef F_FPS
    if ( ! nofps ) {
      // fps counter
      if ( TimGetSeconds() == fps_lasttime ) {
	fps_counter++;
      } else {
	StrIToA ( fps_buffer + 4, fps_counter * 2 );
	fps_counter = 0;
	fps_lasttime = TimGetSeconds();
      }
      WinDrawChars ( "          ", 10, 120, 140 );
      WinDrawChars ( fps_buffer, StrLen ( fps_buffer ), 120, 140 );
    }
#endif

    if ( g_pnobridge -> flags & BF_AUDIO ) {
      audio_gen();
    }

    /* throttle?
     */
#if 0
    {
      static UInt32 lasttime = 0;
      if ( lasttime ) {
	while ( TimGetTicks() - lasttime < ticks_per_sec / 30 ) {
	  // spin
	  if ( g_pnobridge -> flags & BF_AUDIO ) {
	    audio_gen();
	  }
	}
      }
      lasttime = TimGetTicks();
    } // throttle
#endif

  } // while running

  /* kill coleco off
   */
  if ( backbuffer ) {
    MemPtrFree ( backbuffer );
  }

  // done
  return ( 0 );
}

UInt32 host_events ( UInt32 foo ) {
  UInt32 r;
  UInt32 arg;

  arg = BRIDGE_events | ( foo << BRIDGESHIFT );
  arg = ByteSwap32 ( arg );

  r = g_my_call68KFuncP ( g_my_emulStateP,
			  (UInt32) g_pnobridge -> eventf, &arg, 4 );

  return ( r );
}

UInt32 host_get_skip ( UInt8 foo ) {
  UInt32 r;
  UInt32 arg;

  arg = BRIDGE_get_skip | ( foo << BRIDGESHIFT );
  arg = ByteSwap32 ( arg );

  r = g_my_call68KFuncP ( g_my_emulStateP,
			  (UInt32) g_pnobridge -> eventf, &arg, 4 );

  return ( r );
}

long int StrAToI ( const char *ptr ) {
  UInt8 params [ 4 ];

  params [ 0 ] = (UInt8)((UInt32)(ptr) >> 24);
  params [ 1 ] = (UInt8)((UInt32)(ptr) >> 16);
  params [ 2 ] = (UInt8)((UInt32)(ptr) >> 8);
  params [ 3 ] = (UInt8)(ptr);

  return ((long int)((g_my_call68KFuncP)( (void *)(g_my_emulStateP),
				       (0xA0CE & (0x00000FFF)),
				       &params, sizeof(params))));
}

UInt32 TimGetTicks ( void ) {
  return (( UInt32)((g_my_call68KFuncP)( (void*)(g_my_emulStateP),
					 (0xA0F7 & (0x00000FFF)), 0, 0)));
}

UInt16 SysTicksPerSecond ( void ) {
  return (( UInt16)((g_my_call68KFuncP)( (void*)(g_my_emulStateP),
					 (0xA2E9 & (0x00000FFF)), 0, 0)));
}

UInt32 KeyCurrentState ( void ) {
  return (( UInt32)((g_my_call68KFuncP)( (void*)(g_my_emulStateP),
					 (0xA2A2 & (0x00000FFF)), 0, 0)));
}

void *GetObjectPtr ( UInt16 objectID ) {
  FormPtr frmP;
  frmP = FrmGetActiveForm();
  return FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, objectID));
}

void *MemGluePtrNewL ( UInt32 foo ) {
  UInt32 r;
  UInt32 arg;

  arg = BRIDGE_MemGluePtrNew | ( foo << BRIDGESHIFT );
  arg = ByteSwap32 ( arg );

  r = g_my_call68KFuncP ( g_my_emulStateP,
			  (UInt32) g_pnobridge -> eventf, &arg, 4 );

  return ( (UInt8*) r );
}

UInt16 palm_vfs_iter ( void ) {
  return ( g_pnobridge -> vfs_vol );
}

UInt16 palm_vfs_count ( void ) {
  return ( g_pnobridge -> vfs_max );
}

/* -----------------------------------------------------------------------
 */
UInt16 palmap [ 16 ];
#if 0
void SetColor ( byte N, byte R, byte G, byte B ) {
  //XPal [ N ] = ( ( (R) << 11 ) | ( (G) << 5 ) | B );
  XPal [ N ] = N;
  R >>= 3;
  G >>= 2;
  B >>= 3;
  palmap [ N ] = ( ( (R) << 11 ) | ( (G) << 5 ) | B );
  return;
}
#endif

void stubaudiof ( void *s ) {
  UInt32 r;
  UInt32 arg;
  UInt32 foo = (UInt32) s;

  arg = BRIDGE_accum | ( ((foo&0xFFFF0000)>>16) << 8 );
  arg = ByteSwap32 ( arg );
  r = g_my_call68KFuncP ( g_my_emulStateP,
			  (UInt32) g_pnobridge -> eventf, &arg, 4 );

  arg = BRIDGE_setaudio | ( (foo&0x0000FFFF) << 8 );
  arg = ByteSwap32 ( arg );
  r = g_my_call68KFuncP ( g_my_emulStateP,
			  (UInt32) g_pnobridge -> eventf, &arg, 4 );

  return;
}

Err audio_callback_extended
  ( void *userData, SndStreamRef stream, void *buffer, UInt32* bufsize )
{
  UInt32 size = *bufsize;
  Int16 *bufptr = buffer;
  UInt8 *sndbuf = (void*) ByteSwap32 ( ((UInt32)userData) );

#ifdef AUDIO_ARM
  MemMove ( buffer, g_pnobridge -> audio_buf, bufsize );
#endif

  return ( errNone );
}

void error ( char *msg, ... ) {
  debuglog ( msg );
  return;
}

void audio_gen ( void ) {
  Int16 *buf_ptr = (Int16 *) g_pnobridge -> audio_buf;
  UInt8 *source = (UInt8*) buf_ptr;
  UInt16 max;
  UInt8 scale;

  if ( source [ 0 ] == 0 ) {
    source [ 0 ] = 1;
    source += 2;
    source += AUDIO_BUFSIZE_BYTES;
  } else {
    source [ 0 ] = 0;
    source += 2;
  }
  buf_ptr = (Int16*) source;

  // vcs
  Tia_process_2 ( buf_ptr, AUDIO_BUFSIZE_BYTES );

  return;
}

// 0 == blit; 1 == lock; 2 == unlock
UInt32 stubzodiacblit ( UInt32 mode ) {
  UInt32 r;
  UInt32 arg;

  arg = BRIDGE_zodiacblit | ( mode << BRIDGESHIFT );
  arg = ByteSwap32 ( arg );

  r = g_my_call68KFuncP ( g_my_emulStateP,
			  (UInt32) g_pnobridge -> eventf, &arg, 4 );

  return ( r );
}
