 /*
  * filereq.h - GamePark 32 file requester declarations
  * Copyright (c)2002 Christian Nowak <chnowak@web.de>
  *
  *
  * This is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  *
  * It is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with Foobar; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */

#ifndef __FILEREQ_H__
#define __FILEREQ_H__

#ifdef __cplusplus
extern "C" {
#endif

#include "gpgraphic.h"

typedef char BOOL;

typedef struct FSEL
  {
    char * fname;                /* Pointer to a buffer which will be filled with the selected file's name */
    GPDRAWSURFACE * gpDraw;      /* Pointer to the GP32 surface which will be used for gfx output */
    unsigned char bgcolor;       /* Background color */
    unsigned char dircolor;      /* Directory entry color */
    unsigned char filecolor;     /* File entry color */
    unsigned char dirselcolor;   /* Selected directory entry color */
    unsigned char fileselcolor;  /* Selected file entry color */
    unsigned char curdircolor;   /* Color of current directory display at the top of the screen */
  } FSEL;

int FileRequest ( FSEL * fsel, char * bdir, BOOL enableCancel );
/* fsel: Pointer to an FSEL structure
 * bdir: Base directory
 * enableCancel: TRUE if the user should be able to cancel with the B button
 *
 * Functions returns 0 if everything is ok and -1 if an error occured or the 
 * user has canceled the file selector
 */

#ifdef __cplusplus
  }
#endif

#endif

